#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six8004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six8004xi = {
                1:'-106x259y-749z',
                2:'-109x3y-792z',
                3:'-116x246y-752z',
                4:'-117x9y-791z',
                5:'-124x17y-790z',
                6:'-124x758y-223z',
                7:'-125x233y-754z',
                8:'-127x546y-569z',
                9:'-131x24y-788z',
                10:'-133x220y-757z',
                11:'-134x760y-209z',
                12:'-137x33y-787z',
                13:'-140x206y-759z',
                14:'-143x43y-785z',
                15:'-146x193y-762z',
                16:'-148x53y-784z',
                17:'-151x179y-764z',
                18:'-152x63y-782z',
                19:'-153x533y-575z',
                20:'-155x165y-767z',
                21:'-155x75y-781z',
                22:'-158x151y-769z',
                23:'-158x87y-779z',
                24:'-160x138y-771z',
                25:'-160x99y-777z',
                26:'-161x111y-775z',
                27:'-161x125y-773z',
                28:'-163x748y-230z',
                29:'-173x750y-217z',
                30:'-179x519y-581z',
                31:'-201x736y-238z',
                32:'-204x504y-586z',
                33:'-211x737y-225z',
                34:'-228x487y-591z',
                35:'-239x722y-246z',
                36:'-23x323y-731z',
                37:'-249x723y-233z',
                38:'-250x469y-597z',
                39:'-271x450y-602z',
                40:'-275x706y-253z',
                41:'-286x707y-240z',
                42:'-291x430y-607z',
                43:'-310x410y-612z',
                44:'-311x689y-261z',
                45:'-321x689y-248z',
                46:'-327x388y-618z',
                47:'-342x366y-623z',
                48:'-345x669y-268z',
                49:'-356x343y-628z',
                50:'-356x669y-255z',
                51:'-369x320y-633z',
                52:'-378x648y-276z',
                53:'-380x296y-637z',
                54:'-389x647y-263z',
                55:'-390x272y-642z',
                56:'-398x248y-647z',
                57:'-39x314y-734z',
                58:'-402x13y-691z',
                59:'-405x224y-652z',
                60:'-408x35y-687z',
                61:'-410x199y-656z',
                62:'-410x625y-283z',
                63:'-412x57y-682z',
                64:'-414x175y-661z',
                65:'-415x80y-678z',
                66:'-417x103y-674z',
                67:'-417x151y-665z',
                68:'-418x127y-670z',
                69:'-421x623y-270z',
                70:'-441x600y-291z',
                71:'-451x598y-278z',
                72:'-470x574y-298z',
                73:'-480x572y-285z',
                74:'-497x546y-306z',
                75:'-504x620y-2z',
                76:'-507x544y-293z',
                77:'-523x517y-313z',
                78:'-533x514y-300z',
                79:'-536x593y-10z',
                80:'-547x487y-320z',
                81:'-557x484y-308z',
                82:'-55x305y-737z',
                83:'-566x564y-18z',
                84:'-569x456y-328z',
                85:'-579x452y-315z',
                86:'-589x423y-335z',
                87:'-595x533y-26z',
                88:'-599x419y-322z',
                89:'-608x390y-342z',
                90:'-618x385y-330z',
                91:'-622x501y-34z',
                92:'-624x356y-349z',
                93:'-634x351y-337z',
                94:'-639x321y-357z',
                95:'-647x468y-42z',
                96:'-652x286y-364z',
                97:'-662x250y-371z',
                98:'-670x433y-50z',
                99:'-671x214y-378z',
                100:'-678x177y-385z',
                101:'-682x141y-392z',
                102:'-684x32y-413z',
                103:'-685x104y-399z',
                104:'-685x68y-406z',
                105:'-691x397y-58z',
                106:'-69x294y-740z',
                107:'-70x568y-558z',
                108:'-711x360y-66z',
                109:'-728x322y-74z',
                110:'-730x355y-387z',
                111:'-743x283y-82z',
                112:'-756x243y-90z',
                113:'-767x203y-98z',
                114:'-775x163y-106z',
                115:'-782x122y-113z',
                116:'-786x80y-121z',
                117:'-788x39y-129z',
                118:'-82x283y-743z',
                119:'-84x765y-215z',
                120:'-94x271y-746z',
                121:'-99x558y-564z'}

#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire800six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire800six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE800SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six800x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six800x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE800SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
